<?php

class AddItemController {
    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2002_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    public function addItem()
    {
        $account_id = $_REQUEST['account_id'];
        $coin_num  =  $_REQUEST['coin_num'];
        $diamond_num = $_REQUEST['diamond_num'];
        $keys_num  = $_REQUEST['keys_num'];
        $tank_id = $_REQUEST['tank_id'];
        $tank_num =  $_REQUEST['tank_num'];
        $commander_id =  $_REQUEST['commander_id'];
        $commander_num = $_REQUEST['commander_num'];
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            die();
            return;
        }

        if ($coin_num != 0) {
            $row1 = $conn->execQueryOne('SELECT coin_num FROM user WHERE accountid=:accountid;',
                                        array(
                                            ':accountid' => $account_id
                                        ));
            $ret = $conn->execScript('UPDATE user SET coin_num=:coin_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':coin_num' => $coin_num + $row1['coin_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
        }
        if ($commander_id > 14000 && $commander_id < 15000) {
            $rowCommander = $conn->execQueryOne('SELECT fragment_num FROM commander WHERE accountid=:accountid AND commander_id=:commander_id;',
                                                array(
                                                    ':accountid' => $account_id,
                                                    ':commander_id' => $commander_id
                                                ));
            $ret = $conn->execScript('UPDATE commander SET fragment_num=:fragment_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND commander_id=:commander_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':commander_id' => $commander_id,
                                         ':fragment_num' => $commander_num + $rowCommander['fragment_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
        }
        if ($keys_num != 0) {
            $rowkey = $conn->execQueryOne('SELECT keys_num FROM user WHERE accountid=:accountid;',
                                          array(
                                              ':accountid' => $account_id
                                          ));
            $ret = $conn->execScript('UPDATE user SET keys_num=:keys_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':keys_num' => $keys_num + $rowkey['keys_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
        }
        if ($diamond_num != 0) {
            $rowDiamond = $conn->execQueryOne('SELECT diamond_num FROM user WHERE accountid=:accountid;',
                                              array(
                                                  ':accountid' => $account_id
                                              ));
            $ret = $conn->execScript('UPDATE user SET diamond_num=:diamond_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':diamond_num' => $diamond_num + $rowDiamond['diamond_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
        }
        if ($tank_id > 15000 && $tank_id < 16000) {
            $rowTank = $conn->execQueryOne('SELECT fragment_num FROM tank WHERE accountid=:accountid AND tank_id=:tank_id;',
                                           array(
                                               ':accountid' => $account_id,
                                               ':tank_id' => $tank_id
                                           ));
            $ret = $conn->execScript('UPDATE tank SET fragment_num=:fragment_num, modify_time=:modify_time ' .
                                     ' WHERE accountid=:accountid AND tank_id=:tank_id;',
                                     array(
                                         ':accountid' => $account_id,
                                         ':tank_id' => $tank_id,
                                         ':fragment_num' => $tank_num + $rowTank['fragment_num'],
                                         ':modify_time' => time()
                                     ));
            if (!$ret) {
                die();
                return;
            }
        }
        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => '',
        ));
    }
}
?>
